# ncurses 5.9 - patch 20150329 - Thomas E. Dickey
#
# ------------------------------------------------------------------------------
#
# Ncurses 5.9 is at
# 	ftp.gnu.org:/pub/gnu
#
# Patches for ncurses 5.9 are in the subdirectory
# 	ftp://invisible-island.net/ncurses/5.9
#
# ------------------------------------------------------------------------------
# ftp://invisible-island.net/ncurses/5.9/ncurses-5.9-20150329.patch.gz
# patch by Thomas E. Dickey <dickey@invisible-island.net>
# created  Sun Mar 29 17:28:34 UTC 2015
# ------------------------------------------------------------------------------
# NEWS                             |    6 +++++-
# VERSION                          |    2 +-
# configure                        |    8 ++++----
# configure.in                     |    6 +++---
# dist.mk                          |    4 ++--
# ncurses/base/lib_screen.c        |   30 ++++++++++++++++--------------
# package/debian-mingw/changelog   |    4 ++--
# package/debian-mingw64/changelog |    4 ++--
# package/debian/changelog         |    4 ++--
# package/mingw-ncurses.nsi        |    4 ++--
# package/mingw-ncurses.spec       |    2 +-
# package/ncurses.spec             |    2 +-
# 12 files changed, 41 insertions(+), 35 deletions(-)
# ------------------------------------------------------------------------------
Index: NEWS
Prereq:  1.2363 
--- ncurses-5.9-20150328+/NEWS	2015-03-28 21:50:39.000000000 +0000
+++ ncurses-5.9-20150329/NEWS	2015-03-29 14:38:58.000000000 +0000
@@ -25,7 +25,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: NEWS,v 1.2363 2015/03/28 21:50:39 tom Exp $
+-- $Id: NEWS,v 1.2365 2015/03/29 14:38:58 tom Exp $
 -------------------------------------------------------------------------------
 
 This is a log of changes that ncurses has gone through since Zeyd started
@@ -45,6 +45,10 @@
 Changes through 1.9.9e did not credit all contributions;
 it is not possible to add this information.
 
+20150329
+	+ correct cut/paste error for "--enable-ext-putwin" that made it the
+	  same as "--enable-ext-colors" (report by Roumen Petrov)
+
 20150328
 	+ add "-f" option to test/savescreen.c to help with testing/debugging
 	  the extended putwin/getwin.
Index: VERSION
--- ncurses-5.9-20150328+/VERSION	2015-03-27 10:27:01.000000000 +0000
+++ ncurses-5.9-20150329/VERSION	2015-03-29 14:32:33.000000000 +0000
@@ -1 +1 @@
-5:0:9	5.9	20150328
+5:0:9	5.9	20150329
Index: configure
--- ncurses-5.9-20150328+/configure	2015-03-28 00:29:14.000000000 +0000
+++ ncurses-5.9-20150329/configure	2015-03-29 14:39:21.000000000 +0000
@@ -1,5 +1,5 @@
 #! /bin/sh
-# From configure.in Revision: 1.600 .
+# From configure.in Revision: 1.601 .
 # Guess values for system-dependent variables and create Makefiles.
 # Generated by Autoconf 2.52.20141204.
 #
@@ -11646,9 +11646,9 @@
 echo "$as_me:11646: checking if you want to use extended putwin/screendump" >&5
 echo $ECHO_N "checking if you want to use extended putwin/screendump... $ECHO_C" >&6
 
-# Check whether --enable-ext-colors or --disable-ext-colors was given.
-if test "${enable_ext_colors+set}" = set; then
-  enableval="$enable_ext_colors"
+# Check whether --enable-ext-putwin or --disable-ext-putwin was given.
+if test "${enable_ext_putwin+set}" = set; then
+  enableval="$enable_ext_putwin"
   with_ext_putwin=$enableval
 else
   with_ext_putwin=no
Index: configure.in
Prereq:  1.600 
--- ncurses-5.9-20150328+/configure.in	2015-03-27 10:48:27.000000000 +0000
+++ ncurses-5.9-20150329/configure.in	2015-03-29 14:33:54.000000000 +0000
@@ -28,14 +28,14 @@
 dnl
 dnl Author: Thomas E. Dickey 1995-on
 dnl
-dnl $Id: configure.in,v 1.600 2015/03/27 10:48:27 tom Exp $
+dnl $Id: configure.in,v 1.601 2015/03/29 14:33:54 tom Exp $
 dnl Process this file with autoconf to produce a configure script.
 dnl
 dnl See http://invisible-island.net/autoconf/ for additional information.
 dnl
 dnl ---------------------------------------------------------------------------
 AC_PREREQ(2.52.20030208)
-AC_REVISION($Revision: 1.600 $)
+AC_REVISION($Revision: 1.601 $)
 AC_INIT(ncurses/base/lib_initscr.c)
 AC_CONFIG_HEADER(include/ncurses_cfg.h:include/ncurses_cfg.hin)
 
@@ -1078,7 +1078,7 @@
 
 ###   use option --enable-ext-putwin to turn on extended screendumps
 AC_MSG_CHECKING(if you want to use extended putwin/screendump)
-AC_ARG_ENABLE(ext-colors,
+AC_ARG_ENABLE(ext-putwin,
 	[  --enable-ext-putwin     compile with extended putwin/screendump],
 	[with_ext_putwin=$enableval],
 	[with_ext_putwin=no])
Index: dist.mk
Prereq:  1.1040 
--- ncurses-5.9-20150328+/dist.mk	2015-03-27 10:27:01.000000000 +0000
+++ ncurses-5.9-20150329/dist.mk	2015-03-29 14:32:33.000000000 +0000
@@ -25,7 +25,7 @@
 # use or other dealings in this Software without prior written               #
 # authorization.                                                             #
 ##############################################################################
-# $Id: dist.mk,v 1.1040 2015/03/27 10:27:01 tom Exp $
+# $Id: dist.mk,v 1.1041 2015/03/29 14:32:33 tom Exp $
 # Makefile for creating ncurses distributions.
 #
 # This only needs to be used directly as a makefile by developers, but
@@ -37,7 +37,7 @@
 # These define the major/minor/patch versions of ncurses.
 NCURSES_MAJOR = 5
 NCURSES_MINOR = 9
-NCURSES_PATCH = 20150328
+NCURSES_PATCH = 20150329
 
 # We don't append the patch to the version, since this only applies to releases
 VERSION = $(NCURSES_MAJOR).$(NCURSES_MINOR)
Index: ncurses/base/lib_screen.c
Prereq:  1.70 
--- ncurses-5.9-20150328+/ncurses/base/lib_screen.c	2015-03-29 00:16:00.000000000 +0000
+++ ncurses-5.9-20150329/ncurses/base/lib_screen.c	2015-03-29 15:25:29.000000000 +0000
@@ -41,7 +41,7 @@
 #define CUR SP_TERMTYPE
 #endif
 
-MODULE_ID("$Id: lib_screen.c,v 1.70 2015/03/29 00:16:00 tom Exp $")
+MODULE_ID("$Id: lib_screen.c,v 1.72 2015/03/29 15:25:29 tom Exp $")
 
 #define MAX_SIZE 0x3fff		/* 16k is big enough for a window or pad */
 
@@ -321,7 +321,7 @@
     T(("decode_chtype '%s'", source));
     source = decode_attr(source, &attr, &color);
     source = decode_char(source, &value);
-    *target = ChCharOf(value) | attr | COLOR_PAIR(color);
+    *target = (ChCharOf(value) | attr | (chtype) COLOR_PAIR(color));
     /* FIXME - ignore combining characters */
     return source;
 }
@@ -334,6 +334,7 @@
     attr_t attr = fillin->attr;
     wchar_t chars[CCHARW_MAX];
     int append = 0;
+    int value = 0;
 
     T(("decode_cchar  '%s'", source));
     *target = blank;
@@ -344,14 +345,14 @@
 #endif
     source = decode_attr(source, &attr, &color);
     memset(chars, 0, sizeof(chars));
-    source = decode_char(source, &chars[0]);
+    source = decode_char(source, &value);
+    chars[0] = (wchar_t) value;
     /* handle combining characters */
     while (source[0] == MARKER && source[1] == APPEND) {
-	int value;
 	source += 2;
 	source = decode_char(source, &value);
 	if (append++ < CCHARW_MAX) {
-	    chars[append] = value;
+	    chars[append] = (wchar_t) value;
 	}
     }
     setcchar(target, chars, attr, (short) color, NULL);
@@ -694,21 +695,22 @@
     }
 #endif
     for (n = 0; n < SIZEOF(source->chars); ++n) {
-	if (source->chars[n] == 0)
+	unsigned uch = source->chars[n];
+	if (uch == 0)
 	    continue;
 	if (n) {
 	    *target++ = MARKER;
 	    *target++ = APPEND;
 	}
 	*target++ = MARKER;
-	if (source->chars[n] > 0xffff) {
-	    sprintf(target, "U%08x", source->chars[n]);
-	} else if (source->chars[n] > 0xff) {
-	    sprintf(target, "u%04x", source->chars[n]);
-	} else if (source->chars[n] < 32 || source->chars[n] >= 127) {
-	    sprintf(target, "%03o", source->chars[n] & 0xff);
+	if (uch > 0xffff) {
+	    sprintf(target, "U%08x", uch);
+	} else if (uch > 0xff) {
+	    sprintf(target, "u%04x", uch);
+	} else if (uch < 32 || uch >= 127) {
+	    sprintf(target, "%03o", uch & 0xff);
 	} else {
-	    switch (source->chars[n]) {
+	    switch (uch) {
 	    case ' ':
 		strcpy(target, "s");
 		break;
@@ -717,7 +719,7 @@
 		*target = '\0';
 		break;
 	    default:
-		sprintf(--target, "%c", source->chars[n]);
+		sprintf(--target, "%c", uch);
 		break;
 	    }
 	}
Index: package/debian-mingw/changelog
--- ncurses-5.9-20150328+/package/debian-mingw/changelog	2015-03-27 10:27:01.000000000 +0000
+++ ncurses-5.9-20150329/package/debian-mingw/changelog	2015-03-29 14:32:33.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (5.9+20150328) unstable; urgency=low
+ncurses6 (5.9+20150329) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Fri, 27 Mar 2015 06:27:01 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 29 Mar 2015 10:32:33 -0400
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian-mingw64/changelog
--- ncurses-5.9-20150328+/package/debian-mingw64/changelog	2015-03-27 10:27:01.000000000 +0000
+++ ncurses-5.9-20150329/package/debian-mingw64/changelog	2015-03-29 14:32:33.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (5.9+20150328) unstable; urgency=low
+ncurses6 (5.9+20150329) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Fri, 27 Mar 2015 06:27:01 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 29 Mar 2015 10:32:33 -0400
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian/changelog
--- ncurses-5.9-20150328+/package/debian/changelog	2015-03-27 10:27:01.000000000 +0000
+++ ncurses-5.9-20150329/package/debian/changelog	2015-03-29 14:32:33.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (5.9+20150328) unstable; urgency=low
+ncurses6 (5.9+20150329) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Fri, 27 Mar 2015 06:27:01 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 29 Mar 2015 10:32:33 -0400
 
 ncurses6 (5.9-20120608) unstable; urgency=low
 
Index: package/mingw-ncurses.nsi
Prereq:  1.93 
--- ncurses-5.9-20150328+/package/mingw-ncurses.nsi	2015-03-27 10:27:01.000000000 +0000
+++ ncurses-5.9-20150329/package/mingw-ncurses.nsi	2015-03-29 14:32:33.000000000 +0000
@@ -1,4 +1,4 @@
-; $Id: mingw-ncurses.nsi,v 1.93 2015/03/27 10:27:01 tom Exp $
+; $Id: mingw-ncurses.nsi,v 1.94 2015/03/29 14:32:33 tom Exp $
 
 ; TODO add examples
 ; TODO bump ABI to 6
@@ -10,7 +10,7 @@
 !define VERSION_MAJOR "5"
 !define VERSION_MINOR "9"
 !define VERSION_YYYY  "2015"
-!define VERSION_MMDD  "0328"
+!define VERSION_MMDD  "0329"
 !define VERSION_PATCH ${VERSION_YYYY}${VERSION_MMDD}
 
 !define MY_ABI   "5"
Index: package/mingw-ncurses.spec
--- ncurses-5.9-20150328+/package/mingw-ncurses.spec	2015-03-27 10:53:15.000000000 +0000
+++ ncurses-5.9-20150329/package/mingw-ncurses.spec	2015-03-29 14:32:33.000000000 +0000
@@ -3,7 +3,7 @@
 Summary: shared libraries for terminal handling
 Name: mingw32-ncurses6
 Version: 5.9
-Release: 20150328
+Release: 20150329
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: package/ncurses.spec
--- ncurses-5.9-20150328+/package/ncurses.spec	2015-03-27 10:27:01.000000000 +0000
+++ ncurses-5.9-20150329/package/ncurses.spec	2015-03-29 14:32:33.000000000 +0000
@@ -1,7 +1,7 @@
 Summary: shared libraries for terminal handling
 Name: ncurses6
 Version: 5.9
-Release: 20150328
+Release: 20150329
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
